'''
Sequence example.

:copyright: Copyright 2021 AXY axy@declassed.art
:license: BSD, see LICENSE for details.
'''

from textwrap import dedent

from ..core import Template
from ..extras.sequence import SequenceMixin

class Example(Template, SequenceMixin('seq')):

    snippet = dedent('''
        Initialize the sequence, i.e. start from 5:
        {seq:first(5)}

        Generate numbers 6, 7, 8, 10, 9:
        {seq:next()},
        {seq:next()},
        {seq:next()}
        {seq:next(10)}
        {seq:prev()}
    ''')
    result = dedent('''
        Initialize the sequence, i.e. start from 5:
        5

        Generate numbers 6, 7, 8, 10, 9:
        6,
        7,
        8
        10
        9
    ''')

def test_sequence():
    template = Example()
    context = template.render()
    assert context['snippet'].strip() == template.result.strip()
